import pytest
from a5 import *

@pytest.fixture(scope="session", autouse=True)
def model():
    lm = UnigramModel()
    lm.train(['the', 'the', 'the', 'the', 'the', 'the', 
              'a', 'a', 'a', 'a', 'a', 'a',
              'an', 'an', 'an', 'an', 'an',
              'is', 'is', 'is', 'is', 'is',
              'it', 'it', 'it', 'it', 'it',
              'them', 'them',
              'at', 'at', 
              'on', 'on', 
              'and', 'and', 
              'eat', 'eat', 'eat', 
              'to', 'to', 'to', 
              'good'
              'man',
              'thema',
              'toe',])
    return lm

@pytest.mark.parametrize("inp, out",
    [
        ("isitgoodtoeat", "is it good to eat"),
        ("theman", "them an"),
        # with oov
        ("themanruns", "them an runs"),
        # all oov
        ("wannalookatanotherbook", "wannalookatanotherbook"),
    ]
)
def test_segmentation(model, inp, out):
    assert segment_sequence(inp, prob_func=model.get_logprob) == out
